use super::Kartesian;
use num::*;

pub trait MaximumFromMap<T: Integer> {
    fn maximum<U>(map: &Vec<Vec<U>>) -> Kartesian<T>;
}

impl MaximumFromMap<u32> for Kartesian<u32> {
    fn maximum<U>(map: &Vec<Vec<U>>) -> Kartesian<u32> {
        Kartesian {
            x: map.len().to_u32().unwrap(),
            y: map[0].len().to_u32().unwrap(),
        }
    }
}

impl MaximumFromMap<u64> for Kartesian<u64> {
    fn maximum<U>(map: &Vec<Vec<U>>) -> Kartesian<u64> {
        Kartesian {
            x: map.len().to_u64().unwrap(),
            y: map[0].len().to_u64().unwrap(),
        }
    }
}

impl MaximumFromMap<u128> for Kartesian<u128> {
    fn maximum<U>(map: &Vec<Vec<U>>) -> Kartesian<u128> {
        Kartesian {
            x: map.len().to_u128().unwrap(),
            y: map[0].len().to_u128().unwrap(),
        }
    }
}

impl MaximumFromMap<usize> for Kartesian<usize> {
    fn maximum<U>(map: &Vec<Vec<U>>) -> Kartesian<usize> {
        Kartesian { x: map.len(), y: map[0].len() }
    }
}
