use num::*;

macro_rules! predefined_const {
    ($trait_name:ident, $const:ident, $t:ty) => {
        impl $trait_name for $t {
            const $const: $t = <$t>::$const;
        }
    };
}

pub trait CheckedBasicMath: CheckedAdd + CheckedSub {}
impl<T: CheckedAdd + CheckedSub> CheckedBasicMath for T {}

pub trait MaximumValue {
    const MAX: Self;
}
predefined_const!(MaximumValue, MAX, u8);
predefined_const!(MaximumValue, MAX, u16);
predefined_const!(MaximumValue, MAX, u32);
predefined_const!(MaximumValue, MAX, u64);
predefined_const!(MaximumValue, MAX, u128);
predefined_const!(MaximumValue, MAX, usize);
predefined_const!(MaximumValue, MAX, i8);
predefined_const!(MaximumValue, MAX, i16);
predefined_const!(MaximumValue, MAX, i32);
predefined_const!(MaximumValue, MAX, i64);
predefined_const!(MaximumValue, MAX, i128);
predefined_const!(MaximumValue, MAX, isize);
pub trait MinimumValue {
    const MIN: Self;
}
predefined_const!(MinimumValue, MIN, u8);
predefined_const!(MinimumValue, MIN, u16);
predefined_const!(MinimumValue, MIN, u32);
predefined_const!(MinimumValue, MIN, u64);
predefined_const!(MinimumValue, MIN, u128);
predefined_const!(MinimumValue, MIN, usize);
predefined_const!(MinimumValue, MIN, i8);
predefined_const!(MinimumValue, MIN, i16);
predefined_const!(MinimumValue, MIN, i32);
predefined_const!(MinimumValue, MIN, i64);
predefined_const!(MinimumValue, MIN, i128);
predefined_const!(MinimumValue, MIN, isize);
